<?php

//===================================
// Plugin MULTIVIEWER pour SPIP v2.0
//
// fichier : balise/multiviewer.php version 1.0.1
//
// Auteur : Ch.Boutin
//===================================

// limitation :
// - un document n'est ajout q'une fois (clef idocument dans la liste)

// Autre info :
// Pour ajouter des modules : Voir fichier ../modules/modules_liste.php


if (!defined("_ECRIRE_INC_VERSION")) return;


//------------------------------------------
// PLUGIN : NOUVELLES BALISES
//------------------------------------------
// SPIP appelle cette fonction  la rencontre de #MULTIVIEWER
// $p ramne le contexte de compilation


//------------------------------------------
function balise_MULTIVIEWER($p)
{

    // liste des arguments  rcuprer
    $tabArg = array();
    $tabArg["COMMANDE"] = "";  // la commande du plugin
    $tabArg["PARAMETRE"] = ""; // l'id de la galerie  crer
    $tabArg["VALEUR"] = "";    // les valeur "size='12';titre='Ce titre';color='#4A5B6C'"

    // on prend nom de la cle primaire de l'objet pour calculer sa valeur
    if (isset($p->boucles[$p->id_boucle]->primary))
    {
        $_id_objet = $p->boucles[$p->id_boucle]->primary;
        $idobjet = champ_sql($_id_objet, $p);
        $objet = $p->boucles[$p->id_boucle]->id_table;
    }
    else
    {
        $idobjet = 0;
        $objet = "aucun";
    }

    // Recuperation des paramettres (adaptatif  la dfinition)
    // Si existe, on affecte la variable
    $i = 0 ;
    Foreach ($tabArg as $arg => $v )
    {
            $i=$i+1;
            $tabArg[$arg] = interprete_argument_balise($i,$p);
            //traitement pour passer dans la ligne de fonction
            $tabArg[$arg] = ($tabArg[$arg]=="")?"''":$tabArg[$arg];
    }

    $strCode = "calculer_balise_MULTIVIEWER(".$tabArg['COMMANDE']
                                              .",".$tabArg['PARAMETRE']
                                              .",".$tabArg['VALEUR']
                                              .",'$objet', $idobjet)";
    $p->code = $strCode;

    $p->interdire_scripts = false;

    return $p;
} // function balise_MULTIVIEWER




//------------------------------------------
function calculer_balise_MULTIVIEWER($COMMANDE='',$PARAMETRE='',$VALEUR='',$objet='',$idobjet='')
{

    $strHTML="";
    //$strHTML.="<br/>Dispatch : Cde:'".$COMMANDE."' param:'".$PARAMETRE."' valeur:'".$VALEUR."'<hr/>";

    //dfinir les commandes autorises
    $tabCDE_Valide = array();

    $tabCDE_Valide ["ALL"] = "ALL";
    $tabCDE_Valide ["TOUS"] = "ALL";

    $tabCDE_Valide ["NEW"] = "NEW";
    $tabCDE_Valide ["NOUVEAU"] = "NEW";

    $tabCDE_Valide ["AJOUTERDOC"] = "AJOUTERDOC";
    $tabCDE_Valide ["ADD"] = "AJOUTERDOC";
    $tabCDE_Valide ["AJOUTER"] = "AJOUTERDOC";

    $tabCDE_Valide ["VOIRFLASH"] = "VOIRFLASH";
    $tabCDE_Valide ["VOIR"] = "VOIRFLASH";
    $tabCDE_Valide ["VIEW"] = "VOIRFLASH";

    $tabCDE_Valide ["PARAM"] = "PARAM";
    $tabCDE_Valide ["SET"] = "PARAM";

    // liste des arguments  rcuprer  (interface)
    $strCDE = $COMMANDE;
    $tabArg = array();
    $tabArg["PARAMETRE"] = $PARAMETRE; // l'id de la galerie  crer
    $tabArg["VALEUR"] = $VALEUR;    // les valeurs

    // Vrifier et Dfinir la fonction  appeler
    if (array_key_exists($strCDE,$tabCDE_Valide))
    {
        $nomfonction="MULTIVIEWER_".$tabCDE_Valide[$strCDE];
        $strHTML.=$nomfonction($tabArg,$objet,$idobjet);
    }
    else
    {
        if ( $COMMANDE != "" )
        {
            // la commande n'est pas vide, mais n'a pas t reconnue
            $strHTML.=MULTIVIEWER_ERREUR('Cette Commande '.$COMMANDE.' est inconnue');
        }
        else
        {
            // la commande est vide : crer une galerie de tous les doc image.
            $strHTML.=MULTIVIEWER_ALL('',$objet,$idobjet);
        }
    }
    return $strHTML;
} // function calculer_balise_MULTIVIEWER



//------------------------------------------
function MULTIVIEWER_ERREUR($strTXTERREUR, $strTYPE = "ERREUR")
{
    return "\n\n<br/><b>"
           .$strTYPE." dans le Plugin MULTIVIEWER</b> : "
           .$strTXTERREUR."<br/>\n\n";
} // function MULTIVIEWER_ERREUR

//--------------------------------------------------------
// PLUGIN : LES FONCTIONS QUI REALISE LE TRAVAIL A FAIRE
//--------------------------------------------------------


//------------------------------------------
function MULTIVIEWER_ALL($tabArg,$objet, $id_objet)
{

    $strHTML ="";

    //$strHTML.="<br/>ALL, J'ai re&ccedil;u param:'".$tabArg["PARAMETRE"]."' valeur:'".$tabArg["VALEUR"]." (galerie retenue '".$idgalerie."')"."(objet:$objet,$id_objet)<br/>";

    If ($objet=="articles" || $objet=="rubriques")
    {
        $$tabArgEnvoi["COMMANDE"]="ALL";
        $tabArgEnvoi["VALEUR"]=(-1);
        $tabArgEnvoi["PARAMETRE"]=$tabArg["PARAMETRE"];

        $strHTML .= MULTIVIEWER_NEW($tabArg,$objet,$id_objet);
        if ($tabArg["PARAMETRE"]!="")
        $strHTML .= MULTIVIEWER_PARAM($tabArg,$objet,$id_objet);
        $strHTML .= MULTIVIEWER_AJOUTERDOC($tabArgEnvoi,$objet,$id_objet);
        $strHTML .= MULTIVIEWER_VOIRFLASH($tabArg,$objet,$id_objet);
    }
    else
    {
        $strHTML .= MULTIVIEWER_ERREUR("L'utilisation de la balise MULTIVIEWER ALL n'est utilisable que dans un contexte ARTICLE ou RUBRIQUE.","INFO");
    }

//    return MULTIVIEWER_ERREUR("L'utilisation de la balise MULTIVIEWER sans param&egrave;tre n'est pas encore d&eacute;finie... (prochainement dispo)","INFO");
    return $strHTML;

} // function MULTIVIEWER_ALL



//------------------------------------------
// initialise le plugin et charge les modules viewer
function MULTIVIEWER_NEW($tabArg,$typeObjet=false,$idObjet=false)
{
    $strRETURN_HTMLCode="";

    // on rcupre id_document si on est dans une boucle documents
    $idgalerie =(int)(($typeObjet=='articles')?$idObjet:0);
    // PAr contre si une valeur a t spcifi, on la privilgie et on crase
    $idgalerie = trim(( ($tabArg["PARAMETRE"]!="")?$tabArg["PARAMETRE"]:$idgalerie));

    //$strRETURN_HTMLCode.="<br/>NEW, J'ai re&ccedil;u param:'".$tabArg["PARAMETRE"]."' valeur:'".$tabArg["VALEUR"]." (galerie retenue '".$idgalerie."')"."<br/>";

    if ($idgalerie=="INIT")
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("param&egrave;tre r&eacute;serv&eacute; (NEW)");
    }
    // A VOIR COMMENT UTILISER...
    //else if (is_array($GLOBALS["MULTIVIEWER"][$idgalerie])
    //         && array_key_exists("new",$GLOBALS["MULTIVIEWER"][$idgalerie])
    //         && $GLOBALS["MULTIVIEWER"][$idgalerie]["new"]=="init" )
    //{
    //    $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Cette galerie est dj dfinie et n'a pas t vue.(NEW)");
    //}
    else if ($idgalerie=="")
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Le nom de la galerie est absent.(NEW)");
    }
    else
    {
        // Tout semble Ok, on continue
        //------------

        if (!@file_exists( _DIR_PLUGIN_MULTIVIEWER."modules/modules_liste.php"))
        {
             $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Le fichier 'modules_liste.php' n'a pas &eacute;t&eacute; trouv&eacute;.(VOIRFLASH)");
        }
        else
        {
            // la constante _DIR_PLUGIN_MULTIVIEWER s'adapte en fonction de l'espace priv ou public
            include_once(_DIR_PLUGIN_MULTIVIEWER."modules/modules_liste.php");

            // lire liste des modules viewer  prendre en compte
            $tab_modules = Array();
            // fichiers inclus : peuvent tre redfinis dans le fichier ../modules/modules_liste.php
            // Pour ajouter des modules : Voir fichier ../modules/modules_liste.php
            $tab_modules ["simpleviewer"] = array( "viewer" => "simpleviewer-free.swf"
                                                       , "module" => "simpleviewer");
            // attention pas de tiret dans le nom du module !!
            $tab_modules ["simpleviewerpro"]   = array( "viewer" => "simpleviewer-pro.swf"
                                                       , "module" => "simpleviewerpro");
            $tab_modules ["postcard"]     = array( "viewer" => "viewer-postcard-free.swf"
                                                       , "module" => "postcard");
            $tab_modules ["autoviewer"]   = array( "viewer" => "autoviewer-free.swf"
                                                       , "module" => "autoviewer");
            $tab_modules ["tiltviewer"]   = array( "viewer" => "TiltViewer-free.swf"
                                                       , "module" => "tiltviewer");
            // choix viewer par dfaut :
            $MULTIVIEWER["typegalerie"] = "autoviewer";
            $MULTIVIEWER["fenhauteur"] = CST_MULTIVIEWER_SWF_HEIGHT;
            $MULTIVIEWER["fenlargeur"] = CST_MULTIVIEWER_SWF_WIDTH;

            // charger les modules supplmentaires
            $GLOBALS["MULTIVIEWER"]["INIT"] = MVW_Init_Application($tab_modules,  $MULTIVIEWER["typegalerie"]);

            // lire config par dfaut
            //------------

            //config par dfaut
            $MULTIVIEWER["TEXTEAVANTTITREPHOTO"] = CST_MULTIVIEWER_TEXTEAVANTTITREPHOTO;
            $MULTIVIEWER["NOM_PERMANENTS_ACCESSIBLES"] = "";// _NOM_PERMANENTS_ACCESSIBLES ???

            //initialisation
            $MULTIVIEWER["listefichiers"] = array();

            //enregistrement en global pour partager avec les autres functions
            $GLOBALS["MULTIVIEWER"][$idgalerie]["param"] = $MULTIVIEWER;

            // attention  placer aprs le ligne prcdente (pour pas couper la branche)
            $strRETURN_HTMLCode .= MVW_change_viewer($idgalerie,$MULTIVIEWER["typegalerie"]);

            $GLOBALS["MULTIVIEWER"][$idgalerie]["compteur"] = 0 ;
            $GLOBALS["MULTIVIEWER"][$idgalerie]["new"] = "init" ;
        }
    }
    return $strRETURN_HTMLCode;
} // fin MULTIVIEWER_NEW



//------------------------------------------
function MVW_change_viewer($idgalerie,$strViewerChoisi)
{
    // on considre que les fonctions qui appellent on vrifi la validit du nom du viewer.


    $strRETURN_HTMLCode = "";

    $nomFichier = _DIR_PLUGIN_MULTIVIEWER."modules/MVW_DEFINITION_".$strViewerChoisi.".php";

    if (!@file_exists($nomFichier))
    {
         $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Le fichier '".$nomFichier."' n'a pas &eacute;t&eacute; trouv&eacute;.(MVW_change_viewer)");
    }
    else
    {
        include_once($nomFichier);

        $strMVW_DEFINITION_Fonction = "MVW_DEFINITION_".$strViewerChoisi;
        // vrifier que la fonction existe

        if ( !function_exists($strMVW_DEFINITION_Fonction) )
        {

            $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("La fonction : ("
                    .$strMVW_DEFINITION_Fonction
                    .") n'est pas definie dans les modules du plugin MULTIVIEWER.");

        }
        else
        {
            // on efface la branche
            // (si on a chang des valeurs c'est tant pis ! faut le faire dans l'ordre)
            $GLOBALS["MULTIVIEWER"][$idgalerie]["param"]["VARIABLES"] = array();
            // on charge la nouvelle config par dfaut du viewer
            $GLOBALS["MULTIVIEWER"][$idgalerie]["param"]["VARIABLES"] = $strMVW_DEFINITION_Fonction();
        }
    }
    return $strRETURN_HTMLCode;
} // function MVW_change_viewer


//------------------------------------------
function MVW_affecter_variable($idgalerie,$nomvariable,$valeur)
{
    $strRETURN_HTMLCode ="";

    $strRETURN_HTMLCode.="<br/>MVW_affecter_variable, J'ai reu idgalerie:'".$idgalerie."'param:'".$nomvariable."' valeur:'".$valeur."'<br/>";

    if (isset($GLOBALS["MULTIVIEWER"][$idgalerie]["param"]["VARIABLES"][$nomvariable]))
    {
        $GLOBALS["MULTIVIEWER"][$idgalerie]["param"]["VARIABLES"][$nomvariable]["VALEUR"] = $valeur;
    }
    else
    {
        $strRETURN_HTMLCode.= MULTIVIEWER_ERREUR("Cette variable".$nomvariable." n'exite pas pour le viewer encours.");
    }

  return $strRETURN_HTMLCode;

} // MVW_affecter_variable



//------------------------------------------
// ajouter une document  la galerie identifie $idgalerie
//function ajouter_doc($idgalerie,$iddocument)
function MULTIVIEWER_AJOUTERDOC($tabArg,$typeObjet,$idObjet)
{
    $strRETURN_HTMLCode="";


    // on rcupre id_document si on est dans une boucle documents
    $iddocument =(int)( ($typeObjet=="documents")?$idObjet :0);
    // PAr contre si une valeur a t spcifi, on la privilgie et on crase
    $iddocument =(int)( ($tabArg["VALEUR"]>0 || $tabArg["VALEUR"]==(-1))
                                           ?$tabArg["VALEUR"]:$iddocument);

    $idgalerie =(int)(($typeObjet=='articles')?$idObjet:0);
    // Par contre si une valeur a t spcifi, on la privilgie et on crase
    $idgalerie = trim(( ($tabArg["PARAMETRE"]!="")?$tabArg["PARAMETRE"]:$idgalerie));

    //$strRETURN_HTMLCode.="<br/>ADD, J'ai reu param:'".$tabArg["PARAMETRE"]."' valeur:'".$tabArg["VALEUR"]."'<br/>";
    //$strRETURN_HTMLCode.="<br/>ADD, Je retiens : idgalerie='".$idgalerie."' iddocument:'".$iddocument."'<br/>";


    if ($iddocument < 1 && $iddocument!=(-1) )
    {
        $strRETURN_HTMLCode .=MULTIVIEWER_ERREUR("document ".$iddocument." non trouv&eacute;... (AJOUTERDOC)");
    }
    elseif ($idgalerie=="INIT")
    {
        $strRETURN_HTMLCode .=MULTIVIEWER_ERREUR("param&egrave;tre r&eacute;serv&eacute; (AJOUTERDOC)");
    }
    else if (is_array($GLOBALS["MULTIVIEWER"])
             && !array_key_exists($idgalerie,$GLOBALS["MULTIVIEWER"]))
    {
        $strRETURN_HTMLCode .=MULTIVIEWER_ERREUR("Cette galerie $idgalerie n'est pas encore d&eacute;finie.(AJOUTERDOC)");
    }
    else if ($idgalerie=="")
    {
        $strRETURN_HTMLCode .=MULTIVIEWER_ERREUR("Le nom de la galerie n'est pas sp&eacute;cifi&eacute;.(AJOUTERDOC)");
    }
    else
    {
        // Tout semble Ok, on continue
        //------------

        if ($iddocument==(-1) && ( $typeObjet=="rubriques" || $typeObjet=="articles" ) )
        {  // selectionner tous les document du contexte
            $table = $GLOBALS["table_prefix"]."_documents AS d"
                   ." JOIN ". $GLOBALS["table_prefix"]."_"."documents_liens AS l"
                   ." ON d.id_document=l.id_document "  ;
            $tabChamps = array( "d.id_document","d.titre", "d.fichier", "d.descriptif","d.hauteur","d.largeur");
            switch ($typeObjet)
            {
            case "articles" :
                $tabWhere =array( "l.id_objet='".$idObjet."' AND l.objet='article'" );
                break;
            case "rubriques" :
                $tabWhere =array( "l.id_objet='".$idObjet."' AND l.objet='rubrique'" );
                break;
            default :
                $tabWhere =array( "l.id_objet='".$idObjet."' AND l.objet='".$typeObjet."'" );
            }
        }
        else
        {  // selectionner le document point
            $table = $GLOBALS["table_prefix"]."_"."documents";
            $tabChamps = array( "id_document","titre", "fichier", "descriptif","hauteur","largeur");
            $tabWhere =array("id_document='".$iddocument."'" );
        }

        //** pour voir la requete dcommenter la ligne ci-dessous
        //MVW_debug("Nbre lignes en retour de la query ci-dessous :".sql_countsel($table,$tabWhere),sql_get_select($tabChamps,$table,$tabWhere));

        // $result = sql_fetsel($tabChamps,$table,$tabWhere); // code alternatif
        $result = sql_select($tabChamps,$table,$tabWhere);
        if (sql_count($result)>0)
        {
             while ($tab=sql_fetch($result))
             {
                 $GLOBALS["MULTIVIEWER"][$idgalerie]["listefichiers"][$tab["id_document"]] = $tab;
                 $GLOBALS["MULTIVIEWER"][$idgalerie]["compteur"]++;
                 //$strRETURN_HTMLCode.="<br/>-".$GLOBALS["MULTIVIEWER"][$idgalerie]["compteur"]."- J'ai ajout doc ".$tab["fichier"]."<br/>";
             }
        }
    }

    return $strRETURN_HTMLCode;
} // function MULTIVIEWER_AJOUTERDOC



//------------------------------------------
// afficher le viewer : donc prparer et insrer le viewer
function MULTIVIEWER_VOIRFLASH($tabArg,$typeObjet,$idObjet)
{
    // la fonction retouren le code HTML  afficher
    $strRETURN_HTMLCode = "";

    // on rcupre id_document si on est dans une boucle documents
    $idgalerie =(int)(($typeObjet=='articles')?$idObjet:0);
    // Par contre si une valeur a t spcifi, on la privilgie et on crase
    $idgalerie = trim(( ($tabArg["PARAMETRE"]!="")?$tabArg["PARAMETRE"]:$idgalerie));

    //$strRETURN_HTMLCode.="<br/>VOIR, J'ai reu param:'".$tabArg["PARAMETRE"]."' valeur:'".$tabArg["VALEUR"]."'<br/>";

    if ($idgalerie=="INIT")
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("param&egrave;tre '".$idgalerie."' r&eacute;serv&eacute;.(VOIRFLASH)");
    }
    else if (is_array($GLOBALS["MULTIVIEWER"])
             && !array_key_exists($idgalerie,$GLOBALS["MULTIVIEWER"]))
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Cette galerie n'est pas d&eacute;finie.(VOIRFLASH)");
    }
    else if ($idgalerie=="")
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Le nom la galerie demand&eacute;e n'est pas mentionn&eacute;.(VOIRFLASH)");
    }
    // A-t-on trouve des images ??
    else if (!count($GLOBALS["MULTIVIEWER"][$idgalerie])>0)
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("La galerie est vide (aucun document).(VOIRFLASH)");
    }
    else
    {
        // Tout semble Ok, on continue
        //------------

        //rcuprer la oonfiguration
        $tabViewerParam = $GLOBALS["MULTIVIEWER"][$idgalerie]["param"];
        $tabGalerieListe = $GLOBALS["MULTIVIEWER"][$idgalerie]["listefichiers"];

        // Quel est le fichier viewer flash  utiliser ?
        if (isset($GLOBALS["MULTIVIEWER"]["INIT"][$tabViewerParam["typegalerie"]]))
        {
             //Quel est le nom du module  utiliser
             $strNomModule =$GLOBALS["MULTIVIEWER"]["INIT"][$tabViewerParam["typegalerie"]]["module"] ;

             if (!@file_exists( _DIR_PLUGIN_MULTIVIEWER."modules/addon-".$strNomModule.".php"))
             {
                  $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Le module demand&eacute; 'addon-"
                                         .$strNomModule.".php' n'a pas &eacute;t&eacute; trouv&eacute;.(VOIRFLASH)");
             }
             else
             {
                include_once(_DIR_PLUGIN_MULTIVIEWER."modules/addon-".$strNomModule.".php");

                $strMVW_XML_Fonction = "MVW_XML_".$strNomModule;
                $strMVW_HTML_Fonction = "MVW_HTML_".$strNomModule;
                // vrifier que les
                if (    !function_exists($strMVW_XML_Fonction)
                     || !function_exists($strMVW_HTML_Fonction) )
                {
                    $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("La fonction : ("
                            .((function_exists($strMVW_XML_Fonction))?$strMVW_HTML_Fonction:$strMVW_XML_Fonction)
                            .") n'est pas definie dans les modules du plugin MULTIVIEWER.");
                }
                else
                {
                    $strMVW_XMLCode = $strMVW_XML_Fonction($idgalerie,$tabGalerieListe,$tabViewerParam);
                    MVW_ecrire_fichierXML($idgalerie,$strMVW_XMLCode );

                    $strRETURN_HTMLCode .= '<div id="flashcontent'.$idgalerie.'">'."\n"
                    .'MultiViewer n&eacute;cessite JavaScript et '
                    .'<a href="http://www.macromedia.com/go/getflashplayer/">le lecteur Flash</a>.'."\n"
                    .'</div>'."\n" ;
                    $strRETURN_HTMLCode .= $strMVW_HTML_Fonction($idgalerie,$tabViewerParam
                             ,$GLOBALS["MULTIVIEWER"]["INIT"][$tabViewerParam["typegalerie"]]["viewer"]);
                    $GLOBALS["MULTIVIEWER"][$idgalerie]["new"]="vue";
                }
            }
        }
        else
        {
            $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Le type de viewer choisi (".$tabViewerParam["typegalerie"]
                                .") n'est pas d&eacute;fini dans les modules du plugin MULTIVIEWER.");
        }
    }
    return $strRETURN_HTMLCode; // return Code HTML
} // function MULTIVIEWER_VOIRFLASH


//------------------------------------------
function MVW_ecrire_fichierXML ($idgalerie,$XMLcode)
{
    // On ecrit le fichier XML
    $file = _DIR_PLUGIN_MULTIVIEWER."xml/gallery_".$idgalerie.".xml";

    if (file_exists($file)) unlink($file);

    if (!$file_handle = fopen($file,"w")) // ?? vrifier si = ou == ??...
    {
        spip_log("[MULTIVIEWER] Impossible d'ouvrir le fichier : ".$file);
    }
    elseif (!fwrite($file_handle, $XMLcode))
    {
        spip_log("[MULTIVIEWER] Impossible d'ecrire dans le fichier : ".$file);
    }
    else
    {
        spip_log("[MULTIVIEWER] Creation reussie du fichier : ".$file);
    }
    fclose($file_handle);
} // function MVW_ecrire_fichierXML



//------------------------------------------
// initialise le plugin et charge les modules viewer
function MULTIVIEWER_PARAM($tabArg,$typeObjet=false,$idObjet=false)
{
    $strRETURN_HTMLCode="";

    // on rcupre id_document si on est dans une boucle documents
    $idgalerie =(int)(($typeObjet=='articles')?$idObjet:0);
    // PAr contre si une valeur a t spcifi, on la privilgie et on crase
    $idgalerie = trim(( ($tabArg["PARAMETRE"]!="")?$tabArg["PARAMETRE"]:$idgalerie));

    //$strRETURN_HTMLCode.="<br/>PARAM, J'ai re&ccedil;u param:'".$tabArg["PARAMETRE"]."' valeur:'".$tabArg["VALEUR"]." (galerie retenue '".$idgalerie."')"."<br/>";

    if ($idgalerie=="INIT")
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("param&egrave;tre r&eacute;serv&eacute; (PARAM)");
    }
    else if (!is_array($GLOBALS["MULTIVIEWER"][$idgalerie])
             || !array_key_exists("new",$GLOBALS["MULTIVIEWER"][$idgalerie])
             || !$GLOBALS["MULTIVIEWER"][$idgalerie]["new"]=="init" )
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Cette galerie n'est pas d&eacute;finie.(PARAM)");
    }
    else if ($idgalerie=="")
    {
        $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Le nom de la galerie est absent.(PARAM)");
    }
    else
    {
        // Tout semble Ok, on continue
        //------------
        $strTxt = trim($tabArg["VALEUR"]);
        $strParametre  = strtoupper(strtok($strTxt, '='));
        $strValeur = strtok('=');

        if ($strParametre == "TYPEGALERIE")
        {
            // attention pour on coupe (rinitialise) la branche
            // suivante :  $GLOBALS["MULTIVIEWER"][$idgalerie]["param"]["VARIABLES"]
            $strRETURN_HTMLCode .= MVW_change_viewer($idgalerie,$strValeur);
            $GLOBALS["MULTIVIEWER"][$idgalerie]["param"]["typegalerie"] = $strValeur;
        }
        else if ($strParametre == "HAUTEUR")
        {
            $GLOBALS["MULTIVIEWER"][$idgalerie]["param"]["fenhauteur"] =
                                ($strValeur > 0 && $strValeur <= CST_MULTIVIEWER_SWF_MAX_HEIGHT )
                                ? $strValeur : CST_MULTIVIEWER_SWF_HEIGHT_MAX ;
        }
        elseif ($strParametre == "LARGEUR")
        {
            $GLOBALS["MULTIVIEWER"][$idgalerie]["param"]["fenlargeur"] =
                                ($strValeur > 0 && $strValeur <= CST_MULTIVIEWER_SWF_MAX_WIDTH )
                                ? $strValeur : CST_MULTIVIEWER_SWF_WIDTH_MAX ;
        }
        else
        {
            $strRETURN_HTMLCode .= MVW_affecter_variable( $idgalerie, $strParametre,$strValeur );
            // $strRETURN_HTMLCode .= MULTIVIEWER_ERREUR("Le nom de param&egrave;tre '".$strParametre."' est inconnu.(PARAM)");
        }
    }
    return $strRETURN_HTMLCode;
} // function MULTIVIEWER_PARAM


// OUTILS ======================================================================

//------------------------------------------
function MVW_getFileName($fichier)
{
    return basename ($fichier,strrchr($fichier,'.'));
} // function MVW_getFileName



//------------------------------------------
function MVW_debug($txt = NULL, $tab = NULL, $commentaire = false )
{
    //pour mmoire
    //  echo "<br/>In function : ".__FUNCTION__." <br/>\n";

    echo "\n\n",($commentaire)?"<!--":($txt)?"<hr/>":"","\n\n";
    echo $txt."\n";
    if ($tab)
    {
         echo "<hr/>Array="."<br/>\n\n";
         print_r($tab);
    }
    echo "\n\n",($commentaire)?"-->":"<hr/>","\n\n";
} // function MVW_debug


// pour mmoire
// &    &#38;    &amp;
// <    &#139;    &lt;
//     &#155;    &gt;
//     &#156;    &oelig;
// "    &#34;    &quot;
//  &agrave;
//  &ccedil;
//  &egrave;
//  &eacute;
//  &ecirc;
//  &euml;
//  &icirc;
//  &iuml;
//  &ugrave;
//  &uuml;
//  &ucirc;




// ce que j'ai appris en crivant ce plugin :

// TESTER ESPACE PRIVE ET PUBLIC :
// if ( !test_espace_prive() )    // ou ( test_espace_prive()==1 )

// REPERTOIRE DU PLUGIN :   _DIR_PLUGIN_MULTIVIEWER
// retourne : "PLUGINS/dossierplugin/" ou "../PLUGINS/dossierplugin/" si espace priv

// interprete_argument_balise($i,$p) pour rcuprer les arguments.
// cette mthode permet de calculer les valeur si on rcupre une balise.
// Exemple : [(#MULTIVIEWER{NEW,[(#ENV{nom}|sinon{#ID_ARTICLE})]})]

?>